﻿
using UnityEngine;
using System.Collections;
using System;
using System.Net;
using System.IO;
using UnityEngine.UI;
using System.Diagnostics;
using System.Collections.Generic;
using System.Linq;

public class particle1 : MonoBehaviour
{

    public TextMesh textMessage;
    public Transform [] planes = new Transform [6] ;
    public Transform[] sphere = new Transform[8];
    
	int frameCount = 0;
    int stackCurrent = 1;

    float currentDist = 0;
    float currentBFError = 0;
    float currentBFTarget = 0;
    float currentBF = 0;
 
	string currentFeedback = "";
    
    string currentPlayer = ""; 
    int currentPlayed = 0; 
    int currentWillPlay = 0; 
    int currentDaySinceLastGame = 0;
    Vector3 vComp;
    Vector3 vCarb;
    Vector3 vProt;

    void Start()
    {
        vComp = planes[0].position; // = new Vector3()
        vCarb = planes[2].position; // = new Vector3()
        vProt = planes[4].position; // = new Vector3()
    }

    void aaApplyPoints( int stack)
    {
        float xorig = 0;
        float yorig = 1;
        float r = 20;
        for (int i = 0; i < 8; i++)
        {
            float dangle = (float)i * 0.789f;
            float c = Mathf.Cos(dangle);
            float s = Mathf.Sin(dangle);
            r = Global.radius * Global.rfactor * Global.gpsNorm[i, stack];
            float xValue = r * (c * xorig - s * yorig);
            float yValue = r * (s * xorig + c * yorig);
            Vector3 temp = new Vector3(xValue, yValue, 0);
            sphere[i].position = temp;
        }
    }
    void aaAnimate()
    {
        if (frameCount > 100)  Global.rfactor *= 0.8f;
        if (frameCount < 20)   Global.rfactor *= 1.2f;
        if (frameCount >= 20 && frameCount <= 100) Global.rfactor = 1f;
        if (Global.rfactor > 1f) Global.rfactor = 1f; 
    }
	void aaReadInNewPlayer()
	{
		
		for (int i = 2; i < Global.stackCountAnthro; i++ )
		{
			if (Global.playerName[stackCurrent] == Global.playerNameAnthro[i])
			{
				currentBF = Global.currentBodyFatAnthro_p1[i];
				currentBFTarget = Global.targetBodyFatAnthro_p1[i];
				currentBFError = Global.currentBodyFatAnthroError_p1[i];
				currentDist = Global.gpsVar[0, stackCurrent];
			}
		}
		for (int i = 2; i < Global.stackCountMatch; i++)
		{
			if (Global.playerName[stackCurrent] == Global.playerNameMatch[i])
			{
				currentPlayer = Global.playerNameMatch[i];
				currentPlayed = Global.played_p1[i];
				currentWillPlay         = Global.willPlay_p1[i];
				currentDaySinceLastGame = (int)Global.dateSinceLastGame_p1[i].TotalDays;
			}
		}
	}

    void FixedUpdate()
    {
        frameCount++;
        if (frameCount % 120 == 0)
        {
            frameCount = 0;

			if (stackCurrent >= Global.stackCountGPS - 1) stackCurrent = 0;
            else stackCurrent++;

			aaReadInNewPlayer();

        }
        aaAnimate();

       	float bigr 			= 1.5f;
        float littler 		= 0.003f;
       	bool carb 			= false;
        bool protein 		= false;
        bool compression 	= false; 

        if (currentBFError < 0 && currentDist > 3500)
        {
            carb = true;
            protein = false;
        }
        if (currentBFError > 10 && currentDist > 3500 && currentDist < 5000)
        {
            carb = false;
            protein = true;
        }
        if (currentDist > 5000)
        {
            carb = true;
            protein = false;
        }
        
        
        if (currentDaySinceLastGame == 1 && currentPlayed > 15 && currentWillPlay == 1) 
		{
			compression = true;
		} 
		else 
		{
			compression = false;
		}

		float dy = 1f*Mathf.Sin(Time.realtimeSinceStartup*10f);
        
		currentFeedback = "Hi " + currentPlayer + "," ;
		if (compression)
        {
            currentFeedback += "\r\n" + "Please wear your compression garment to aid recovery";
            planes[0].position = new Vector3(vComp.x, vComp.y + dy, vComp.z);
            planes[1].position = new Vector3(vComp.x, vComp.y, vComp.z);
            planes[0].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[1].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }
        else
        {
            planes[1].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[0].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }


        if (carb)
        {
            currentFeedback += "\r\n" + "Take a recovery shake this afternoon";
            planes[2].position = new Vector3(vCarb.x, vCarb.y + dy, vCarb.z);
            planes[3].position = new Vector3(vCarb.x, vCarb.y, vCarb.z);

            planes[2].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[3].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }
        else
        {
            planes[2].position = new Vector3(vCarb.x, vCarb.y , vCarb.z);
            planes[3].position = new Vector3(vCarb.x, vCarb.y, vCarb.z);

            planes[3].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[2].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }

        if (protein)
        {
            currentFeedback += "\r\n" + "Take a protein shake this afternoon";
            planes[4].position = new Vector3(vProt.x, vProt.y + dy, vProt.z);
            planes[5].position = new Vector3(vProt.x, vProt.y, vProt.z);

            planes[4].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[5].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }
        else
        {
            planes[4].position = new Vector3(vProt.x, vProt.y, vProt.z);
            planes[5].position = new Vector3(vProt.x, vProt.y, vProt.z);

            planes[5].localScale = new Vector3(Global.rfactor * bigr, Global.rfactor * bigr, Global.rfactor * bigr);
            planes[4].localScale = new Vector3(Global.rfactor * littler, Global.rfactor * littler, Global.rfactor * littler);
        }

        if (!compression &&  !carb && !protein)
        {
            currentFeedback += "\r\n" + "Nothing for you to do this afternoon";
        }
        currentFeedback += "\r\n" + "Thanks" + "\r\n" + "Adam";
        textMessage.text = currentFeedback;
        aaApplyPoints(stackCurrent);
    }
}